
;  File:  LOADTEST.ASM Version 1.0 Aug. 7, 1994      Copyright TAPR 1994
;  By: Bob Stricklin, N5BRG

;  This program test the ability of your computer to load a large block
;  of data into the DSP93. It also checks the resulting program
;  memorys ability to take the data.

;  When the program starts, LED 201 is turned off.

;  The program runs until all defined memory has been tested. 
;
; Copyright (c) 1994 by Tucson Amateur Packet Radio Corporation
; 
; This document, and it executable, are the property of the Tucson Amateur
; Packet Radio Corp., a Arizona non-profit corporation, and all are copyright
; 1994.  Permission is hereby granted for the non-commercial use of these
; properties only by licensed amateur radio operators.  All other rights are
; reserved  by the Tucson Amateur Packet Radio Corp. 
; 
; This software is provided for use only to non-commercial amateur radio
; users.  Commercial inquiries should be made to Tucson Amateur Packet Radio
; Corp.
; 
; TAPR (Tucson Amateur Packet Radio Corporation) makes no warranty of any
; kind, express or implied, including without limitation, any warranties
; and/or fitness for a particular purpose of this software.  TAPR shall not be
; liable for any damages, whether direct, indirect, special or consequential
; arising from a failure of this software to operate in the manner desired by
; the user.  TAPR shall not be liable for any damage to data or property that
; may be caused directly or indirectly by using the software.
; 
; IN NO EVENT WILL TUCSON AMATEUR PACKET RADIO CORP. BE LIABLE FOR ANY
; INCIDENTAL OR CONSEQUENTIAL DAMAGE ARISING OUT OF USE OR INABILITY TO USE
; THE PROGRAM, OR FOR ANY CLAIM BY ANY OTHER PARTY.
;
		.TITLE  "LOADTEST version 1.0"

#define PORTS 
#define MONITOR
#define REGS

#include "PORTS.INC"
#include "MONITOR.INC"
#include "REGS.INC"

;Memory storage location
TEMP    .EQU    30h
COUNT   .EQU    31h
TEST    .EQU    32h
READ    .EQU    33h

;Constants
LAST	.EQU	2600h       ; Highest address in memory to be tested.
VALUE	.EQU	5555h       ; Memory fill value used

        .ORG      1000h

        B         GO        ; branch to program start (TINT)
        B         GO        ; 
        B         GO        ;
        B         GO        ;

GO      DINT                ; shut off interrupts

		LDPK    8           ; Set for external memory
        ZAC                 ; LED OFF
        SACL    TEMP        ; into TEMP
        OUT     TEMP,07h    ; out to latch

        CALL    INBIT       ; Wait for key input

		LDPK    8           ; Set for external memory
        LRLK    AR1,LAST-1  ; point to last memory location
        SAR     AR1,COUNT   ; Track moemory test location in COUNT
TEST1   LARP    AR1         ; Use Register 0
        RSXM                ; Do not use sign bit in math and shifts
		ZAC
        LALK    VALUE       ; Check it with the loaded test value
		SACL    TEST 
		ZAC                 ; Clear Acc
        LAC     COUNT       ; Load the current memory location
        TBLR    READ        ; Get program memory pointed at by Acc -> READ
		LAC     READ        ; Now put READ value inot Acc
        SUB     TEST        ; Test it
        BNZ     TEST_ER     ; If it is incorrect go tell
TEST2   MAR     *-          ; Decrement memory pointer
        SAR     AR1,COUNT   ; Track moemory test location in COUNT
		ZAC
        LALK    FINISH      ; Check it with the loaded test value
		SACL    TEMP 
        ZAC                 ; Clear Acc
        LAC     COUNT       ; Load current pointer location
        SUB     TEMP        ; Checking for end of memory block
        BGEZ    TEST1       ; Keep checking if not at end of block

        LARP    AR0         ; Use Register 0
        LRLK    AR0,0400h   ; point to memory location
        RPTK    S_END-STR1  ; # of words to move
        BLKP    STR1,*+     ; move block of words from Start to AR0 pointer
        LRLK    AR0,0400h   ; point to memory location
		CALL    SD_STR
		B		RESET

TEST_ER SSXM                ; Do not use sign bit in math and shifts
		ZAC
		LDPK    8           ; Set for external memory
		LAC     COUNT
        SACL    PRVAL_MEM   ; Store it in print buffer
        CALL    PRVAL16     ; Go put it on serial port
        CALL    SP2         ; Print 2 spaces on serial port
        LALK    VALUE       ; Get the correct value
        SACL    PRVAL_MEM   ; Store it in print buffer
        CALL    PRVAL16     ; Go put it on serial port
        CALL    SP2         ; Print 2 spaces on serial port
        LARP    AR1         ; Use register 1
        LAC     READ        ; Read the error value from memory
        SACL    PRVAL_MEM   ; Store it in print buffer
        CALL    PRVAL16     ; Go put it on serial port
        CALL    SD_CRLF     ; Print a carrage return and line feed
        LARP    AR1         ; Use register 1
        B       TEST2       ; Go test some more memory


STR1      .TEXT     " E N D   O F   T E S T"
          .WORD     0A0D
          .WORD     00
S_END
FINISH
		.ORG    LAST        ; Filler to get TASM to put values in memory
		.WORD	VALUE 
FIRST 
		.END

