;       .title  "Test Software"
;
; Routine to demo monitor callls
; Bob Stricklin N5BRG
; 12/9/94
;
; Copyright (c) 1994 by Tucson Amateur Packet Radio Corporation
; 
; This document, and it executable, are the property of the Tucson Amateur
; Packet Radio Corp., a Arizona non-profit corporation, and all are copyright
; 1994.  Permission is hereby granted for the non-commercial use of these
; properties only by licensed amateur radio operators.  All other rights are
; reserved  by the Tucson Amateur Packet Radio Corp. 
; 
; This software is provided for use only to non-commercial amateur radio
; users.  Commercial inquiries should be made to Tucson Amateur Packet Radio
; Corp.
; 
; TAPR (Tucson Amateur Packet Radio Corporation) makes no warranty of any
; kind, express or implied, including without limitation, any warranties
; and/or fitness for a particular purpose of this software.  TAPR shall not be
; liable for any damages, whether direct, indirect, special or consequential
; arising from a failure of this software to operate in the manner desired by
; the user.  TAPR shall not be liable for any damage to data or property that
; may be caused directly or indirectly by using the software.
; 
; IN NO EVENT WILL TUCSON AMATEUR PACKET RADIO CORP. BE LIABLE FOR ANY
; INCIDENTAL OR CONSEQUENTIAL DAMAGE ARISING OUT OF USE OR INABILITY TO USE
; THE PROGRAM, OR FOR ANY CLAIM BY ANY OTHER PARTY.
;
#include  "REGS.INC"
#include  "PORTS.INC"
#include  "MONITOR.INC"

; GETVAL_MEM storage used
; GET2HEXMEM storage used
; GET4HEXMEM storage used
; PRVAL_MEM  storage used

MON1      .EQU     060h ;  monitor scratch register
MON2      .EQU     061h ;  monitor scratch register
MON3      .EQU     062h ;  monitor scratch register
MON4      .EQU     063h ;  monitor scratch register
MON5      .EQU     064h ;  monitor scratch register
MON6      .EQU     065h ;  monitor scratch register
MON7      .EQU     066h ;  monitor scratch register
MON8      .EQU     067h ;  monitor scratch register
LOC0      .EQU     040h ;  monitor scratch register
LOC1      .EQU     041h ;  monitor scratch register
LOC2      .EQU     042h ;  monitor scratch register
LOC3      .EQU     043h ;  monitor scratch register
LOC4      .EQU     044h ;  monitor scratch register
LOC5      .EQU     045h ;  monitor scratch register
LOC6      .EQU     046h ;  monitor scratch register
LOC7      .EQU     047h ;  monitor scratch register
LOC8      .EQU     048h ;  monitor scratch register


     .ORG     1000h

MONTEST 
    B       INIT
    B       INIT
    B       INIT
    B       INIT

INIT
    LDPK    8h        ; point to data page
    LARP    AR0       ; Establish a pointer register.
    LALK    0h
    SACL    DEBUGPC  ; flag for debug routine - controls usage see docs.
    LALK    0460h    ; point to first memory location used in page 8.
    SACL    DEBUGML
    ZAC     
    LALK    1234h,8   ; Move data up into MSBs of ACC
    ADLK    56h
    SACL    MON1
    SACL    MON2
    SACL    MON3
    SACL    MON4
    SACL    MON5
    SACL    MON6
    SACL    MON7
    SACL    MON8
    LRLK    AR0,1234h ; Set up a known memory area pointer
    LRLK    AR1,5678h ; Set up a known memory area pointer
    LRLK    AR2,9ABCh ; Set up a known memory area pointer
    LRLK    AR3,0DEF1h ; Set up a known memory area pointer
    LRLK    AR4,2345h ; Set up a known memory area pointer
    LRLK    AR5,6789h ; Set up a known memory area pointer
    LRLK    AR6,0ABCDh ; Set up a known memory area pointer
    LRLK    AR7,0EF12h ; Set up a known memory area pointer
    CALL    DEBUG

    ZAC
    SACL    MON1
    SACL    MON2
    SACL    MON3
    SACL    MON4
    SACL    MON5
    SACL    MON6
    SACL    MON7
    SACL    MON8
    LRLK    AR0,0h    ; Set up a known memory area pointer
    LRLK    AR1,0h    ; Set up a known memory area pointer
    LRLK    AR2,0h    ; Set up a known memory area pointer
    LRLK    AR3,0h    ; Set up a known memory area pointer
    LRLK    AR4,0h    ; Set up a known memory area pointer
    LRLK    AR5,0h    ; Set up a known memory area pointer
    LRLK    AR6,0h    ; Set up a known memory area pointer
    LRLK    AR7,0h    ; Set up a known memory area pointer
    CALL    DEBUG

; Note that the OUTBIT call used in debug changes the values in memory
; location 460h and 462h. To verify this we will loop through the above
; with a different section of memory.


    LALK     0500h    ; point to first memory location used in page 8.
    SACL     DEBUGML
    ZAC     
    LALK    0ABCDh,8   ; Move data up into MSBs of ACC
    ADLK    0EFh
    SACL    LOC1
    SACL    LOC2
    SACL    LOC3
    SACL    LOC4
    SACL    LOC5
    SACL    LOC6
    SACL    LOC7
    SACL    LOC8
    LRLK    AR0,1234h ; Set up a known memory area pointer
    LRLK    AR1,5678h ; Set up a known memory area pointer
    LRLK    AR2,9ABCh ; Set up a known memory area pointer
    LRLK    AR3,0DEF1h ; Set up a known memory area pointer
    LRLK    AR4,2345h ; Set up a known memory area pointer
    LRLK    AR5,6789h ; Set up a known memory area pointer
    LRLK    AR6,0ABCDh ; Set up a known memory area pointer
    LRLK    AR7,0EF12h ; Set up a known memory area pointer
    CALL    DEBUG

	LALK    0FFFFh
    SACL    LOC1
    SACL    LOC2
    SACL    LOC3
    SACL    LOC4
    SACL    LOC5
    SACL    LOC6
    SACL    LOC7
    SACL    LOC8
    LRLK    AR0,0FFFFh    ; Set up a known memory area pointer
    LRLK    AR1,0FFFFh    ; Set up a known memory area pointer
    LRLK    AR2,0FFFFh    ; Set up a known memory area pointer
    LRLK    AR3,0FFFFh    ; Set up a known memory area pointer
    LRLK    AR4,0FFFFh    ; Set up a known memory area pointer
    LRLK    AR5,0FFFFh    ; Set up a known memory area pointer
    LRLK    AR6,0FFFFh    ; Set up a known memory area pointer
    LRLK    AR7,0FFFFh    ; Set up a known memory area pointer
    CALL    DEBUG




START
    ZAC               ; Clear the acc
    ORK     0200h     ; Set L216 LED to on
    SACL    PRVAL_MEM
    OUT     PRVAL_MEM,06h  ; Write to turn L216 on

    CALL    INBIT     ; Demo INBIT by taking in a value
                      ; INBIT leaves resulting data in acc and
                      ; at indirect memory location *
    CALL    OUTBIT    ; Now print the value picked up by INBIT from acc
    CALL    SD_CRLF   ; Send a carrage return and line feed.

    LAC     *         ; Set up to store value in OUTBIT2_MEM.
    SACL    OUTBIT2_MEM ; Memory location output to SIO by OUTBIT2
    CALL    OUTBIT2   ; Now print the value pick up by INBIT
    CALL    SD_CRLF   ; Send a carrage return and line feed.

    LRLK    AR0,2000h ; Establish a memory area in DATA Memory
    RPTK    S_END-STR1; Caluclate the number of times to repeat
    BLKP    STR1,*+   ; Move string block to data memory starting at 2000.

    LARP    AR0       ; Make sure we are working with AR0
    LRLK    AR0,2000h+STR2-STR1 ; point to memory location 
    CALL    SD_STR    ; Go print the string starting with the data at 2000
                      ; Go get 4 HEX characters
    CALL    GET4HEX   ; Value will be in location GETVAL_MEM 
    CALL    SD_CRLF   ; Send a carrage return and line feed.
    LAC     GETVAL_MEM ; GET4HEX returns value in GETVAL_MEM 
    SACL    PRVAL_MEM ; PRVAL16 expects output value to be in PRVAL_MEM
    CALL    PRVAL16   ; Print the value of PRVAL_MEM
    CALL    SD_CRLF   ; Send a carrage return and line feed.

    LRLK    AR0,2000h+STR3-STR1 ; point to memory location 
    CALL    SD_STR    ; Go print the string starting with the data at 2000
                      ; Go get 2 HEX characters
    CALL    GET2HEX   ; Value will be in location GETVAL_MEM 
    CALL    SD_CRLF   ; Send a carrage return and line feed.
    LAC     GET2HEXMEM ; GET2HEX returns value in GETVAL_MEM 
    SACL    PRVAL_MEM ; PRVAL08 expects output value to be in PRVAL_MEM
    CALL    PRVAL08   ; Print the value of PRVAL_MEM
    CALL    SD_CRLF   ; Send a carrage return and line feed.

    LRLK    AR0,2000h+STR4-STR1 ; point to memory location 
    CALL    SD_STR    ; Go print the string starting with the data at 2000
    CALL    GETCHAR   ; Value will be in location GETCAR_MEM 
    CALL    SD_CRLF   ; Send a carrage return and line feed.
    LAC     GETCAR_MEM ; GETCHAR  returns value in GETCAR_MEM 
                      ; 
    CALL    HEXOUT    ; Print the value in ACC
    CALL    SD_CRLF   ; Send a carrage return and line feed.

    ZAC               ; Following code just prints from 1 to 0Bh with
    LALK    0001h     ; Indicated number of spaces between each HEX CHAR.
    CALL    HEXOUT
    CALL    SP1
    LALK    0002h
    CALL    HEXOUT
    CALL    SP2
    LALK    0003h
    CALL    HEXOUT
    CALL    SP3
    LALK    0004h
    CALL    HEXOUT
    CALL    SP4
    LALK    0005h
    CALL    HEXOUT
    CALL    SP5
    LALK    0006h
    CALL    HEXOUT
    CALL    SP6
    LALK    0007h
    CALL    HEXOUT
    CALL    SP7
    LALK    0008h
    CALL    HEXOUT
    CALL    SP8
    LALK    0009h
    CALL    HEXOUT
    CALL    SP9
    LALK    000Ah
    CALL    HEXOUT
    CALL    SP10
    LALK    000Bh
    CALL    HEXOUT
    CALL    SD_CRLF        ; Put a carrage return line feed at the end

    LRLK    AR0,2000h ; point to memory location 
    CALL    SD_STR    ; Go print the string starting with the data at 2000
    CALL    SD_CRLF   ; Send a carrage return and line feed.

    LRLK    AR2,03E8h ; Set up for a 1 second wait.
	                     ; Wait is AR2 value times 1 mS
    CALL    MWAIT_A   ; Just make sure we go out to the waits and come back.
    CALL    MWAIT1    ; Just make sure we go out to the waits and come back.
                      ; 32 mS wait
    B       RESET          ; Goes all the way back to low speed.
                           ; Ready for a new program to be down loaded


STR1 .TEXT   " M O N I T O R   T E S T   C O M P L E T E ."
     .WORD   00h
STR2 .TEXT   " I N 4   H E X >"        
     .WORD   00
STR3 .TEXT   " I N 2   H E X >"        
     .WORD   00
STR4 .TEXT   " I N 1   H E X >"        
     .WORD   00
S_END

    .END              ; end of program

