;  File:  TESTGAIN.ASM                         Copyright TAPR 1994
;  AIO set @ 10,031 samples/second
;  Portions copyright Frank H Perkins, 1993 and Lon Cecil, 1993
;  L201 is fixed active as power indicator
;  Step rate is clock dependent, approx 3 sec per step @ 40 MHz
;  Note that gain and multiplexers are restored to "0000" writes on  
;      ports 06h, 07h and 0Bh
;  Port 07h controls IO201 and 202 input and gain.
;  document  d0-d2 input select 
;  document  d3-d5 input gain
;  document  d6    LED 202
;  document  d7    LED 201
;  26 NOV 93 added FREEZ lines to stop on each input for level setting 
;  with 10K feedback resistors, gain is set to 0.1X at monitor reset.
;  gain is varied with Port 07h D3, D4, D5 bits.
;  STEP sequence with wait periods for REC 1 INPUT default
;
; Copyright (c) 1994 by Tucson Amateur Packet Radio Corporation
; 
; This document, and it executable, are the property of the Tucson Amateur
; Packet Radio Corp., a Arizona non-profit corporation, and all are copyright
; 1994.  Permission is hereby granted for the non-commercial use of these
; properties only by licensed amateur radio operators.  All other rights are
; reserved  by the Tucson Amateur Packet Radio Corp. 
; 
; This software is provided for use only to non-commercial amateur radio
; users.  Commercial inquiries should be made to Tucson Amateur Packet Radio
; Corp.
; 
; TAPR (Tucson Amateur Packet Radio Corporation) makes no warranty of any
; kind, express or implied, including without limitation, any warranties
; and/or fitness for a particular purpose of this software.  TAPR shall not be
; liable for any damages, whether direct, indirect, special or consequential
; arising from a failure of this software to operate in the manner desired by
; the user.  TAPR shall not be liable for any damage to data or property that
; may be caused directly or indirectly by using the software.
; 
; IN NO EVENT WILL TUCSON AMATEUR PACKET RADIO CORP. BE LIABLE FOR ANY
; INCIDENTAL OR CONSEQUENTIAL DAMAGE ARISING OUT OF USE OR INABILITY TO USE
; THE PROGRAM, OR FOR ANY CLAIM BY ANY OTHER PARTY.
;
AR0       .EQU      00h       ;  aux register 0 (equate used by TASM)
AR1       .EQU      01h       ;  aux register 1
AR2       .EQU      02h       ;  aux register 2
AR3       .EQU      03h       ;  aux register 3
AR4       .EQU      04h       ;  aux register 4
AR5       .EQU      05h       ;  aux register 5
AR6       .EQU      06h       ;  aux register 6
AR7       .EQU      07h       ;  aux register 7
DRR       .EQU      00h       ;  SIO receive buffer
DXR       .EQU      01h       ;  SIO transmit buffer
PRD       .EQU      03h       ;  Timer period buffer
IMR       .EQU      04h       ;  INT mask buffer
BUFO      .EQU      060h      ;  SIO output buffer
BUFI      .EQU      061h      ;  SIO input buffer
DO        .EQU      062h      ;  data output buffer
          .ORG      1000h
          B         GO        ;  safety branch to program start
          B         GO        ;  branch to program start
          B         GO        ;  branch to program start
          B         GO        ;  safety branch to program start
GO        DINT                ;  shut off interrupts
          LDPK      00h       ;  data mem page 0
ANA_INI   LALK      0000h     ;  sel AUX in, gain = 1, LEDs OFF
          SACL      DO        ;  into DO
          OUT       DO,07h    ;  out to ANA latch

DSP       LALK      0000h     ;  load DSP start
          SACL      DO        ;  into DO
          OUT       DO,07h    ;  out to Analog Select/gain 
          OUT       DO,06h    ;  out to TNC Output connector 
          OUT       DO,0Bh    ;  out to Radio Control
          CALL WAIT1          ;  Arbitrary about 2 sec @26MHz
      

LED204    LALK      0080h     ;  load LED 204 BRIGHT as active light
          SACL      DO        ;  into DO
          OUT       DO,0Bh    ;  out to LED 204
                              ;  sequence of gain steps 
GAIN000   LALK      0005h     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC - Gain=.3
          LALK      0000h
          SACL      DO
          OUT       DO,06h    ;  L202,L203,L204 DARK
          CALL      WAIT1

GAIN001   LALK      000Dh     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC - Gain=.5
          LALK      0400h     ;  D10 sets L202 bright
          SACL      DO
          OUT       DO,06h    ;  L202 BRIGHT
          CALL      WAIT1

GAIN010   LALK      0015h     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC - Gain=1
          LALK      0200h     ;  D09 sets L203 bright
          SACL      DO
          OUT       DO,06h    ;  L203 BRIGHT
          CALL      WAIT1

GAIN011   LALK      001Dh     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC - Gain=3?
          LALK      0600h
          SACL      DO
          OUT       DO,06h    ;  L203,L204 BRIGHT
          CALL      WAIT1

GAIN100   LALK      0025h     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC - Gain=8?
          LALK      0100h     ; D08 sets L204 bright
          SACL      DO
          OUT       DO,06h    ;  L204 BRIGHT  L202,L203 DARK
          CALL      WAIT1

;         B         FREEZ     ;  insert this line to stop test code

GAIN101   LALK      002Dh     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC - Gain=20?
          LALK      0500h
          SACL      DO
          OUT       DO,06h    ;  L202,L204 BRIGHT   L203 DARK
          CALL      WAIT1

;         B         FREEZ     ;  insert this line to stop test code

GAIN110   LALK      0035h     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC - Gain=50?
          LALK      0300h
          SACL      DO
          OUT       DO,06h    ;  L202 DARK
          CALL      WAIT1

GAIN111   LALK      003Dh     ;  load Radio #1 REC for comparator
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC
          LALK      0700h
          SACL      DO
          OUT       DO,06h    ;  L202,L203,L204 BRIGHT
          CALL      WAIT1

GAINRST   LALK      0005h     ;  load Radio #1 REC
          SACL      DO
          OUT       DO,07h    ;  Write change to Radio #1 REC
          LALK      0000h     ;  load LED 204 DARK
          SACL      DO        ;  into DO
          OUT       DO,0Bh    ;  out to LED 204
          OUT       DO,06h    ;  L202, L203, L204 DARK   
          B         LED204    ;  restart gain sequence
          
          CALL      WAIT1     ;  if error, then clean and restart
          B         DSP       ;  tight loop back

FREEZ     B         FREEZ
          
WAIT1     LARK      AR2,0FFh   ; DOUBLE LOOP wait table
WAIT_A    LARK      AR1,0FFh   ; uses AR1 and AR2
WAIT_B    LARK      AR3,0DFh   ; load 037h for 1 second
WAIT_B2   LARP      AR3
          BANZ      WAIT_B2
          LARP      AR1
          BANZ      WAIT_B
          LARP      AR2
          BANZ      WAIT_A
          RET

          .END
