;  TAPR TEST, 94.06.12     Program copyright TAPR 1994
;  File:  TESTLEDS.ASM
;  AIO set @ 10,031 samples/second
;  Portions initial copyright Frank H Perkins, 1993 and Lon Cecil, 1993
;  Walking light test of LED 201 to LED 207
;  LED208 is fixed active as power indicator
;  Step rate is clock dependent, approx 2 sec per step @ 40 MHz crystal
;  Note that gain and multiplexers are restored to "0000" writes on  
;      ports 06h, 07h and 0Bh.  Radios should be unplugged from port 1 & 2
;  Program runs and loops until CPU reset.
;
; Copyright (c) 1994 by Tucson Amateur Packet Radio Corporation
; 
; This document, and it executable, are the property of the Tucson Amateur
; Packet Radio Corp., a Arizona non-profit corporation, and all are copyright
; 1994.  Permission is hereby granted for the non-commercial use of these
; properties only by licensed amateur radio operators.  All other rights are
; reserved  by the Tucson Amateur Packet Radio Corp. 
; 
; This software is provided for use only to non-commercial amateur radio
; users.  Commercial inquiries should be made to Tucson Amateur Packet Radio
; Corp.
; 
; TAPR (Tucson Amateur Packet Radio Corporation) makes no warranty of any
; kind, express or implied, including without limitation, any warranties
; and/or fitness for a particular purpose of this software.  TAPR shall not be
; liable for any damages, whether direct, indirect, special or consequential
; arising from a failure of this software to operate in the manner desired by
; the user.  TAPR shall not be liable for any damage to data or property that
; may be caused directly or indirectly by using the software.
; 
; IN NO EVENT WILL TUCSON AMATEUR PACKET RADIO CORP. BE LIABLE FOR ANY
; INCIDENTAL OR CONSEQUENTIAL DAMAGE ARISING OUT OF USE OR INABILITY TO USE
; THE PROGRAM, OR FOR ANY CLAIM BY ANY OTHER PARTY.
;
AR0       .EQU      00h       ;  aux register 0 (equate used by TASM)
AR1       .EQU      01h       ;  aux register 1
AR2       .EQU      02h       ;  aux register 2
AR3       .EQU      03h       ;  aux register 3
AR4       .EQU      04h       ;  aux register 4
AR5       .EQU      05h       ;  aux register 5
AR6       .EQU      06h       ;  aux register 6
AR7       .EQU      07h       ;  aux register 7
DRR       .EQU      00h       ;  SIO receive buffer
DXR       .EQU      01h       ;  SIO transmit buffer
PRD       .EQU      03h       ;  Timer period buffer
IMR       .EQU      04h       ;  INT mask buffer
BUFO      .EQU      060h      ;  SIO output buffer
BUFI      .EQU      061h      ;  SIO input buffer
DO        .EQU      062h      ;  data output buffer

          .ORG      1000h     ;  TASM compiler needs explicit start origin
          B         GO        ;  safety branch to program start
          B         GO        ;  branch to program start
          B         GO        ;  branch to program start
          B         GO        ;  safety branch to program start

GO        DINT                ;  shut off interrupts
          LDPK      00h       ;  data mem page 0
ANA_INI   LALK      0000h     ;  sel AUX in, gain = 1, LEDs OFF
          SACL      DO        ;  into DO
          OUT       DO,03h    ;  out to ANA latch, to disable AIO chip

DSP       LALK      0000h     ;  load DSP start
          SACL      DO        ;  into DO
          OUT       DO,07h    ;  out to port 07h 
          OUT       DO,06h
          OUT       DO,0Bh    ;  out to Analog Sel
          CALL WAIT1          ;  ARBITRARY WAIT LOOP  about 2 sec @ 40 MHz
                              ;  only POWER LED should be lighted

LED201    LALK      0080h     ;  load BIT D7 HIGH
          SACL      DO        ;  into DO
          OUT       DO,07h    ;  out to LED 201          
          CALL WAIT1
          
LED202    LALK      0040h     ;  load BIT D6 HIGH
          SACL      DO        ;  into DO
          OUT       DO,07h    ;  out to LED 202
          CALL      WAIT1

          LALK      0000h     ;  dark LED 202
          SACL      DO
          OUT       DO, 07h
LED203    LALK      0040h     ;  load BIT D6 HIGH
          SACL      DO        ;  into DO
          OUT       DO,0Bh    ;  out to LED 203          
          CALL WAIT1

LED204    LALK      0080h     ;  load BIT D7 HIGH
          SACL      DO        ;  into DO
          OUT       DO,0Bh    ;  out to LED 204
          CALL      WAIT1

          LALK      0000h     ;  dark LED 204
          SACL      DO
          OUT       DO, 0Bh

LED205    LALK      0100h     ;  load BIT D8 HIGH
          SACL      DO        ;  into DO
          OUT       DO,06h    ;  out to LED 205
          CALL      WAIT1

LED206    LALK      0200h     ;  load BIT D9 HIGH
          SACL      DO        ;  into DO
          OUT       DO,06h    ;  out to LED 206
          CALL      WAIT1

LED207    LALK      0400h     ;  load BIT D10 HIGH
          SACL      DO        ;  into DO
          OUT       DO,06h    ;  out to LED 207
          CALL      WAIT1

          B         DSP       ; loop back and run again 
          
WAIT1     LARK      AR2,0FFh  ; DOUBLE LOOP wait table
WAIT_A    LARK      AR1,0FFh  ; uses AR1 and AR2
WAIT_B    LARK      AR3,037h
WAIT_B2   LARP      AR3
          BANZ      WAIT_B2
          LARP      AR1
          BANZ      WAIT_B
          LARP      AR2
          BANZ      WAIT_A
          RET

          .END
