;  File:  TESTPORY.ASM                         Copyright TAPR 1994
;  AIO chip reset, with no audio output or conversions
;  Copyright Frank H Perkins, 1993 and Lon Cecil, 1994
;  Walking light test steps on  LED 2 to LED 2.
;  LED208 is fixed active as power indicator
;  Step rate is clock dependent, approx 5 sec per step @ 40 MHz
;  Note that gain and multiplexers are restored to "0000" writes on
;      ports 06h & 07h
;  Port 1 and Port 2 radio controls FUP, FDN & PTT are exercised, in
;      sequence, ACTIVE about 5 seconds each
;  Version for Yaesu 736 (RGP)
;
;
; Copyright (c) 1994 by Tucson Amateur Packet Radio Corporation
;
; This document, and it executable, are the property of the Tucson Amateur
; Packet Radio Corp., a Arizona non-profit corporation, and all are copyright
; 1994.  Permission is hereby granted for the non-commercial use of these
; properties only by licensed amateur radio operators.  All other rights are
; reserved  by the Tucson Amateur Packet Radio Corp.
;
; This software is provided for use only to non-commercial amateur radio
; users.  Commercial inquiries should be made to Tucson Amateur Packet Radio
; Corp.
;
; TAPR (Tucson Amateur Packet Radio Corporation) makes no warranty of any
; kind, express or implied, including without limitation, any warranties
; and/or fitness for a particular purpose of this software.  TAPR shall not be
; liable for any damages, whether direct, indirect, special or consequential
; arising from a failure of this software to operate in the manner desired by
; the user.  TAPR shall not be liable for any damage to data or property that
; may be caused directly or indirectly by using the software.
;
; IN NO EVENT WILL TUCSON AMATEUR PACKET RADIO CORP. BE LIABLE FOR ANY
; INCIDENTAL OR CONSEQUENTIAL DAMAGE ARISING OUT OF USE OR INABILITY TO USE
; THE PROGRAM, OR FOR ANY CLAIM BY ANY OTHER PARTY.
;
AR0       .EQU      00h       ;  aux register 0 (equate used by TASM)
AR1       .EQU      01h       ;  aux register 1
AR2       .EQU      02h       ;  aux register 2
AR3       .EQU      03h       ;  aux register 3
AR4       .EQU      04h       ;  aux register 4
AR5       .EQU      05h       ;  aux register 5
AR6       .EQU      06h       ;  aux register 6
AR7       .EQU      07h       ;  aux register 7
DRR       .EQU      00h       ;  SIO receive buffer
DXR       .EQU      01h       ;  SIO transmit buffer
PRD       .EQU      03h       ;  Timer period buffer
IMR       .EQU      04h       ;  INT mask buffer
BUFO      .EQU      060h      ;  SIO output buffer
BUFI      .EQU      061h      ;  SIO input buffer
DO        .EQU      062h      ;  data output buffer
          .ORG      1000h
          B         GO        ;  safety branch to program start
          B         GO        ;  branch to program start
          B         GO        ;  branch to program start
          B         GO        ;  safety branch to program start
GO        DINT                ;  shut off interrupts
          LDPK      00h       ;  data mem page 0
ANA_INI   LALK      0000h     ;  sel AUX in, gain = 1, LEDs OFF
          SACL      DO        ;  into DO
          OUT       DO,03h    ;  out to ANA latch

DSP       LALK      0000h     ;  load DSP start
          SACL      DO        ;  into DO
          OUT       DO,07h    ;  out to port 07h
          OUT       DO,06h
          LALK      0036h     ;  use LALK 0000h for PTT*/FD*/FU* radios
                              ;  LALK 0036h to port 0Bh (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh    ;  out to Analog Sel


LED202    LALK      0040h     ;  load to light LED 202 and dark LED 201
          SACL      DO        ;  into DO
          OUT       DO,07h    ;  out to LED 202
          LALK      0016h     ;  LALK 0020h to set Port 2 FD Bit 6 HIGH
                              ;  LALK 0016h FD low (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh    ;  out to LED 203
          CALL      WAIT1

LED203    LALK      0000h     ;
          SACL      DO        ;
          OUT       DO,07h    ;  dark LED 202 and LED 201
          LALK      0066h     ;  LALK 0050h to light LED 6 and to also
                              ;  set Port 2 FU Bit 5 HIGH
                              ;  LALK 0066h FD low (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh    ;  out to LED 203
          CALL      WAIT1

LED204    LALK      00BEh     ;  LALK 0088h to light LED 204 and to also
                              ;  set Port 2 PTT Bit 4 HIGH
                              ;  LALK 00BEh FD low (Yaesu 736R PTT*/FD/FU)
          SACL      DO        ;  into DO
          OUT       DO,0Bh    ;  out to LED 204
          CALL      WAIT1
          LALK      0036h     ;  LALK 0000h to clear LED 204
                              ;  LALK 0036h to port 0Bh (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh

LED205    LALK      0100h     ;  load to light LED 205
          SACL      DO        ;  into DO
          OUT       DO,06h    ;  out to LED 205
          LALK      0032h     ;  LALK 0004h Port 1 FD Bit 3 HIGH
                              ;  LALK 0032h to port 0Bh (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh
          CALL      WAIT1

LED206    LALK      0200h     ;  load to light LED 206
          SACL      DO        ;  into DO
          OUT       DO,06h    ;  out to LED
          LALK      0034h     ;  LALK 0002h Port 1 FU BIT 2 HIGH
                              ;  LALK 0034h to port 0Bh (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh
          CALL      WAIT1

LED207    LALK      0400h     ;  load to light LED 207
          SACL      DO        ;  into DO
          OUT       DO,06h    ;  out to LED
          LALK      0037h     ;  LALK 0001h Prt 1 PTT BIT 1 HIGH
                              ;  LALK 0037h to 0Bh (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh
          CALL      WAIT1

          LALK      0000h     ;
          SACL      DO        ;
          OUT       DO,06h    ;  out to dark LED 207
          LALK      0036h     ;  LALK 0000h clear bits
                              ;  LALK 0036h to 0Bh (Yaesu 736R PTT*/FD/FU)
          SACL      DO
          OUT       DO,0Bh    ;  out to Port
          CALL      WAIT1

          B         DSP

FREEZ     B         FREEZ

WAIT1     LARK      AR2,0FFh   ; DOUBLE LOOP wait table
WAIT_A    LARK      AR1,0FFh   ; uses AR1 and AR2
WAIT_B    LARK      AR3,067h
WAIT_B2   LARP      AR3
          BANZ      WAIT_B2
          LARP      AR1
          BANZ      WAIT_B
          LARP      AR2
          BANZ      WAIT_A
          RET

          .END
